/*------------------------------------------------------------------------------*
 * Architecture & Implementation of DBMS                                        *
 *------------------------------------------------------------------------------*
 * Copyright 2019 Databases and Information Systems Group TU Dortmund          *
 *                                                                              *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  *
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL      *
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR         *
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,        *
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR        *
 * OTHER DEALINGS IN THE SOFTWARE.                                              *
 *------------------------------------------------------------------------------*
 */

#include <storage/lru_policy.h>

using namespace aidbms::storage;

Frame* LRUPolicy::evict(std::unordered_map<PageID, Frame *> &locations)
{
    /**
     * TODO:    Implement an eviction strategy based on the LRU Replacement Policy.
     *
     * Choose one frame from locations and return it
     * as that frame you want to evict from the buffer.
     */

	 return nullptr;
}

void LRUPolicy::onPin(PageID page_id, TimeStamp time)
{
    /**
     * Called every time a new page is pinned by the buffer manager.
     * Used for collecting statistics about pinned pages like the
     * timestamp to evict the oldest one.
     */
}

void LRUPolicy::onUnpin(PageID page_id, TimeStamp)
{
    /**
     * Called every time a page will be removed from the buffer manager.
     */
}
